#region Using directives

using System;
using System.Collections.Generic;
using System.Text;

#endregion

namespace LspEvents
{
    class Program
    {
        static void Main(string[] args)
        {
            // Instantiate an LSP
            Lsp lsp = new Lsp("LSP123", 1, 5, "R2R3R4R5", 100, 150);

            // Register event handlers.          
            lsp.FullyCongested += new Lsp.LspEventHandler(FullyCongested);
            lsp.GettingCongested += new Lsp.LspEventHandler(GettingCongested);
            lsp.CannotForwardData += new Lsp.LspEventHandler(CannotForwardData);

            // Forward some blocks of data (to generate some events.)
            Console.WriteLine("\n***** Forwarding data *****");
            for (int i = 0; i < 3; i++)
                lsp.ForwardSomeData(20);

            Console.WriteLine("\n***** Forwarding more data *****");
            for (int i = 0; i < 2; i++)
                lsp.ForwardSomeData(20);

            Console.ReadLine();
        }

        public static void FullyCongested(string msg)
        {
        	Console.WriteLine(msg); 
        }

        public static void GettingCongested(string msg)
        {
        	Console.WriteLine(msg);
			Console.WriteLine("Service Suggestion:");
        	Console.WriteLine("To maintain service, please allocate more or " +
        	                  "free some bandwidth.");
			Console.WriteLine();
        }
        
        public static void CannotForwardData(string msg)
        {
        	Console.WriteLine(msg);
			Console.WriteLine("Service Suggestion:");
			Console.WriteLine("To restart the forwarding service, please allocate more or " +
        	                  "free some bandwidth.");
			Console.WriteLine();
        }
    }
}
